// This example shows how to read value of a single OPC item, and display it.
// It is designed to only use C++ language features and libraries that are portable across compilers.

// Uses: STLSoft C and C++ Libraries, http://sourceforge.net/projects/stlsoft
// Uses: VOLE - A Neat C++ COM/Automation Driver, http://sourceforge.net/projects/vole
// You need to properly set the include directories to STLSoft and VOLE libraries.

// Tested with libraries: STLSoft 1.9.124, VOLE 0.7.3
// Tested with compiler: Microsoft (R) C/C++ Optimizing Compiler Version 17.00.50727.1 for x86 (Visual Studio 2012)
// Tested with compiler: Microsoft (R) C/C++ Optimizing Compiler Version 17.00.50727.1 for x64 (Visual Studio 2012)

#include <vole/vole.hpp>
#include <comstl/util/initialisers.hpp>
#include <stdlib.h>

int main()
{
	using vole::object;
	using vole::collection;

	// Initialize OLE libraries
	comstl::ole_initialiser oleinit;

	// Instatiate the EasyOPC-DA client object
	object client = object::create("OpcLabs.EasyOpc.DataAccess.EasyDAClient", CLSCTX_ALL, vole::coercion_level::valueCoercion);

	double value = client.invoke_method<double>(L"ReadItemValue", 
		/*varMachineName:*/	L"",
		/*varServerClass:*/	L"OPCLabs.KitServer.2", 
		/*varItemId:*/		L"Simulation.Random");

	printf("value: %g\n", value);

	char line[80];
	puts("Press Enter to continue...");
	fgets(line, sizeof(line), stdin);

	return EXIT_SUCCESS;
}
